﻿Public Class Form1

    Dim ComPort As String
    Dim RecvDataBuff As String

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim PortList As String()
        Dim PortName As String

        PortList = IO.Ports.SerialPort.GetPortNames() '利用可能なシリアルポート名の配列取得
        ComboBox1.Items.Clear()

        For Each PortName In PortList           'シリアルポート名をコンボボックスにセット
            ComboBox1.Items.Add(PortName)
        Next PortName

        If ComboBox1.Items.Count > 0 Then      '選択初期化
            ComboBox1.SelectedIndex = 0
        End If
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        ComPort = ComboBox1.SelectedItem.ToString()
        SerialPort1.Close()
        SerialPort1.PortName = ComPort

        Try
            SerialPort1.Open()            'シリアルポートオープン
        Catch ex As Exception
            MsgBox(ex.Message)
            Exit Sub
        End Try
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        SerialPort1.Close()                 'ポートクローズ
    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        'シリアルポートをオープンしていない場合、処理を行わない.
        If SerialPort1.IsOpen = False Then
            Return
        End If

        TextBox2.Text = ""
        RecvDataBuff = ""
        SerialPort1.Write(TextBox1.Text + vbCrLf)             'コマンド送信実行
    End Sub

    Private Delegate Sub Delegate_RcvDataToText(ByVal data As String)

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        'シリアルポートをオープンしていない場合、処理を行わない.
        If SerialPort1.IsOpen = False Then
            Return
        End If

        RecvDataBuff = RecvDataBuff + SerialPort1.ReadExisting() 'データ受信
        If InStr(RecvDataBuff, vbCrLf) = 0 Then Exit Sub 'CRLF未受信?

        Dim args(0) As Object
        args(0) = RecvDataBuff
        Invoke(New Delegate_RcvDataToText(AddressOf Me.subRcvDataToText), args) '受信したデータをラベルに書込
    End Sub

    Private Sub subRcvDataToText(ByVal data As String)
        If IsNothing(data) = False Then         '受信文字あり？
            TextBox2.Text = data                '受信文字表示
        End If
    End Sub

End Class
